/*
;    Project:       Open Vehicle Monitor System
;    Date:          14th March 2017
;
;    Changes:
;    1.0  Initial release
;
;    (C) 2011       Michael Stegen / Stegen Electronics
;    (C) 2011-2017  Mark Webb-Johnson
;    (C) 2011        Sonny Chen @ EPRO/DX
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
; THE SOFTWARE.
*/

#include <stdint.h>
#include "pcp.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/semphr.h"
#include "driver/gpio.h"
//CSW #include "spi_master_nodma.h"
#include "driver/spi_common.h"   //CSW added
#include "driver/spi_master.h"

#ifndef __SPI_H__
#define __SPI_H__

class spi : public pcp, public InternalRamAllocated
  {
  public:
    spi(const char* name, int misopin, int mosipin, int clkpin);
    virtual ~spi();

  public:
    bool LockBus(TickType_t delay = portMAX_DELAY);
    void UnlockBus();
    //CSW uint8_t* spi_cmd(spi_nodma_device_handle_t spi, uint8_t* buf, int rxlen, int txlen, ...);
    uint8_t* spi_cmd(spi_device_handle_t spi, uint8_t* buf, int rxlen, int txlen, ...);
    //CSW esp_err_t spi_deselect(spi_nodma_device_handle_t spi);

  public:
    //CSWspi_nodma_bus_config_t m_buscfg;
    spi_bus_config_t m_buscfg;
    spi_host_device_t m_host;
    bool m_initialized;
  protected:
    SemaphoreHandle_t m_mtx;

  };

#endif //#ifndef __SPI_H__
